Subject: Re: [PATCH net-next V2 3/3] net/mlx4_en: Add ethtool statistics for XDP cases

From: Brenden Blanco <[email-masked]>
Date: Tue, 1 Nov 2016 15:06:04 -0600

On Tue, Nov 01, 2016 at 01:36:26PM +0200, Tariq Toukan wrote:
> XDP statistics are reported in ethtool as follows:
> - xdp_drop: the number of packets dropped by xdp.
> - xdp_tx: the number of packets forwarded by xdp.
> - xdp_tx_full: the number of times an xdp forward failed
> 	due to a full tx xdp ring.
> 
> In addition, all packets that are dropped/forwarded by XDP
> are no longer accounted in rx_packets/rx_bytes of the ring,
> so that they count traffic that is passed to the stack.
This seems like a step backwards, in that I now no longer have any
statistic whatsoever that can count xdp packets per-ring. For instance,
how would I validate that my flow-hash rules are operating correctly? I
would suggest to restore the rxN_packet/bytes stat increment.
> 
> Signed-off-by: Tariq Toukan <[email-masked]>
> ---
>  drivers/net/ethernet/mellanox/mlx4/en_ethtool.c | 14 ++++++++++++++
>  drivers/net/ethernet/mellanox/mlx4/en_netdev.c  |  4 ++++
>  drivers/net/ethernet/mellanox/mlx4/en_port.c    |  6 ++++++
>  drivers/net/ethernet/mellanox/mlx4/en_rx.c      | 12 +++++++-----
>  drivers/net/ethernet/mellanox/mlx4/en_tx.c      |  8 ++++----
>  drivers/net/ethernet/mellanox/mlx4/mlx4_en.h    |  7 ++++++-
>  drivers/net/ethernet/mellanox/mlx4/mlx4_stats.h | 10 +++++++++-
>  7 files changed, 50 insertions(+), 11 deletions(-)
[...]